const KNOWN_ERROR_MESSAGE_IDS = new Set([
  "psmerr-ssl-disabled",
  "psmerr-ssl2-disabled",
  "psmerr-hostreusedissuerandserial",
  "ssl-error-export-only-server",
  "ssl-error-us-only-server",
  "ssl-error-no-cypher-overlap",
  "ssl-error-no-certificate",
  "ssl-error-bad-certificate",
  "ssl-error-bad-client",
  "ssl-error-bad-server",
  "ssl-error-unsupported-certificate-type",
  "ssl-error-unsupported-version",
  "ssl-error-wrong-certificate",
  "ssl-error-bad-cert-domain",
  "ssl-error-post-warning",
  "ssl-error-ssl2-disabled",
  "ssl-error-bad-mac-read",
  "ssl-error-bad-mac-alert",
  "ssl-error-bad-cert-alert",
  "ssl-error-revoked-cert-alert",
  "ssl-error-expired-cert-alert",
  "ssl-error-ssl-disabled",
  "ssl-error-fortezza-pqg",
  "ssl-error-unknown-cipher-suite",
  "ssl-error-no-ciphers-supported",
  "ssl-error-bad-block-padding",
  "ssl-error-rx-record-too-long",
  "ssl-error-tx-record-too-long",
  "ssl-error-rx-malformed-hello-request",
  "ssl-error-rx-malformed-client-hello",
  "ssl-error-rx-malformed-server-hello",
  "ssl-error-rx-malformed-certificate",
  "ssl-error-rx-malformed-server-key-exch",
  "ssl-error-rx-malformed-cert-request",
  "ssl-error-rx-malformed-hello-done",
  "ssl-error-rx-malformed-cert-verify",
  "ssl-error-rx-malformed-client-key-exch",
  "ssl-error-rx-malformed-finished",
  "ssl-error-rx-malformed-change-cipher",
  "ssl-error-rx-malformed-alert",
  "ssl-error-rx-malformed-handshake",
  "ssl-error-rx-malformed-application-data",
  "ssl-error-rx-unexpected-hello-request",
  "ssl-error-rx-unexpected-client-hello",
  "ssl-error-rx-unexpected-server-hello",
  "ssl-error-rx-unexpected-certificate",
  "ssl-error-rx-unexpected-server-key-exch",
  "ssl-error-rx-unexpected-cert-request",
  "ssl-error-rx-unexpected-hello-done",
  "ssl-error-rx-unexpected-cert-verify",
  "ssl-error-rx-unexpected-client-key-exch",
  "ssl-error-rx-unexpected-finished",
  "ssl-error-rx-unexpected-change-cipher",
  "ssl-error-rx-unexpected-alert",
  "ssl-error-rx-unexpected-handshake",
  "ssl-error-rx-unexpected-application-data",
  "ssl-error-rx-unknown-record-type",
  "ssl-error-rx-unknown-handshake",
  "ssl-error-rx-unknown-alert",
  "ssl-error-close-notify-alert",
  "ssl-error-handshake-unexpected-alert",
  "ssl-error-decompression-failure-alert",
  "ssl-error-handshake-failure-alert",
  "ssl-error-illegal-parameter-alert",
  "ssl-error-unsupported-cert-alert",
  "ssl-error-certificate-unknown-alert",
  "ssl-error-generate-random-failure",
  "ssl-error-sign-hashes-failure",
  "ssl-error-extract-public-key-failure",
  "ssl-error-server-key-exchange-failure",
  "ssl-error-client-key-exchange-failure",
  "ssl-error-encryption-failure",
  "ssl-error-decryption-failure",
  "ssl-error-socket-write-failure",
  "ssl-error-md5-digest-failure",
  "ssl-error-sha-digest-failure",
  "ssl-error-mac-computation-failure",
  "ssl-error-sym-key-context-failure",
  "ssl-error-sym-key-unwrap-failure",
  "ssl-error-pub-key-size-limit-exceeded",
  "ssl-error-iv-param-failure",
  "ssl-error-init-cipher-suite-failure",
  "ssl-error-session-key-gen-failure",
  "ssl-error-no-server-key-for-alg",
  "ssl-error-token-insertion-removal",
  "ssl-error-token-slot-not-found",
  "ssl-error-no-compression-overlap",
  "ssl-error-handshake-not-completed",
  "ssl-error-bad-handshake-hash-value",
  "ssl-error-cert-kea-mismatch",
  "ssl-error-no-trusted-ssl-client-ca",
  "ssl-error-session-not-found",
  "ssl-error-decryption-failed-alert",
  "ssl-error-record-overflow-alert",
  "ssl-error-unknown-ca-alert",
  "ssl-error-access-denied-alert",
  "ssl-error-decode-error-alert",
  "ssl-error-decrypt-error-alert",
  "ssl-error-export-restriction-alert",
  "ssl-error-protocol-version-alert",
  "ssl-error-insufficient-security-alert",
  "ssl-error-internal-error-alert",
  "ssl-error-user-canceled-alert",
  "ssl-error-no-renegotiation-alert",
  "ssl-error-server-cache-not-configured",
  "ssl-error-unsupported-extension-alert",
  "ssl-error-certificate-unobtainable-alert",
  "ssl-error-unrecognized-name-alert",
  "ssl-error-bad-cert-status-response-alert",
  "ssl-error-bad-cert-hash-value-alert",
  "ssl-error-rx-unexpected-new-session-ticket",
  "ssl-error-rx-malformed-new-session-ticket",
  "ssl-error-decompression-failure",
  "ssl-error-renegotiation-not-allowed",
  "ssl-error-unsafe-negotiation",
  "ssl-error-rx-unexpected-uncompressed-record",
  "ssl-error-weak-server-ephemeral-dh-key",
  "ssl-error-next-protocol-data-invalid",
  "ssl-error-feature-not-supported-for-ssl2",
  "ssl-error-feature-not-supported-for-servers",
  "ssl-error-feature-not-supported-for-clients",
  "ssl-error-invalid-version-range",
  "ssl-error-cipher-disallowed-for-version",
  "ssl-error-rx-malformed-hello-verify-request",
  "ssl-error-rx-unexpected-hello-verify-request",
  "ssl-error-feature-not-supported-for-version",
  "ssl-error-rx-unexpected-cert-status",
  "ssl-error-unsupported-hash-algorithm",
  "ssl-error-digest-failure",
  "ssl-error-incorrect-signature-algorithm",
  "ssl-error-next-protocol-no-callback",
  "ssl-error-next-protocol-no-protocol",
  "ssl-error-inappropriate-fallback-alert",
  "ssl-error-weak-server-cert-key",
  "ssl-error-rx-short-dtls-read",
  "ssl-error-no-supported-signature-algorithm",
  "ssl-error-unsupported-signature-algorithm",
  "ssl-error-missing-extended-master-secret",
  "ssl-error-unexpected-extended-master-secret",
  "sec-error-io",
  "sec-error-library-failure",
  "sec-error-bad-data",
  "sec-error-output-len",
  "sec-error-input-len",
  "sec-error-invalid-args",
  "sec-error-invalid-algorithm",
  "sec-error-invalid-ava",
  "sec-error-invalid-time",
  "sec-error-bad-der",
  "sec-error-bad-signature",
  "sec-error-expired-certificate",
  "sec-error-revoked-certificate",
  "sec-error-unknown-issuer",
  "sec-error-bad-key",
  "sec-error-bad-password",
  "sec-error-retry-password",
  "sec-error-no-nodelock",
  "sec-error-bad-database",
  "sec-error-no-memory",
  "sec-error-untrusted-issuer",
  "sec-error-untrusted-cert",
  "sec-error-duplicate-cert",
  "sec-error-duplicate-cert-name",
  "sec-error-adding-cert",
  "sec-error-filing-key",
  "sec-error-no-key",
  "sec-error-cert-valid",
  "sec-error-cert-not-valid",
  "sec-error-cert-no-response",
  "sec-error-expired-issuer-certificate",
  "sec-error-crl-expired",
  "sec-error-crl-bad-signature",
  "sec-error-crl-invalid",
  "sec-error-extension-value-invalid",
  "sec-error-extension-not-found",
  "sec-error-ca-cert-invalid",
  "sec-error-path-len-constraint-invalid",
  "sec-error-cert-usages-invalid",
  "sec-internal-only",
  "sec-error-invalid-key",
  "sec-error-unknown-critical-extension",
  "sec-error-old-crl",
  "sec-error-no-email-cert",
  "sec-error-no-recipient-certs-query",
  "sec-error-not-a-recipient",
  "sec-error-pkcs7-keyalg-mismatch",
  "sec-error-pkcs7-bad-signature",
  "sec-error-unsupported-keyalg",
  "sec-error-decryption-disallowed",
  "sec-error-no-krl",
  "sec-error-krl-expired",
  "sec-error-krl-bad-signature",
  "sec-error-revoked-key",
  "sec-error-krl-invalid",
  "sec-error-need-random",
  "sec-error-no-module",
  "sec-error-no-token",
  "sec-error-read-only",
  "sec-error-no-slot-selected",
  "sec-error-cert-nickname-collision",
  "sec-error-key-nickname-collision",
  "sec-error-safe-not-created",
  "sec-error-baggage-not-created",
  "sec-error-bad-export-algorithm",
  "sec-error-exporting-certificates",
  "sec-error-importing-certificates",
  "sec-error-pkcs12-decoding-pfx",
  "sec-error-pkcs12-invalid-mac",
  "sec-error-pkcs12-unsupported-mac-algorithm",
  "sec-error-pkcs12-unsupported-transport-mode",
  "sec-error-pkcs12-corrupt-pfx-structure",
  "sec-error-pkcs12-unsupported-pbe-algorithm",
  "sec-error-pkcs12-unsupported-version",
  "sec-error-pkcs12-privacy-password-incorrect",
  "sec-error-pkcs12-cert-collision",
  "sec-error-user-cancelled",
  "sec-error-pkcs12-duplicate-data",
  "sec-error-message-send-aborted",
  "sec-error-inadequate-key-usage",
  "sec-error-inadequate-cert-type",
  "sec-error-cert-addr-mismatch",
  "sec-error-pkcs12-unable-to-import-key",
  "sec-error-pkcs12-importing-cert-chain",
  "sec-error-pkcs12-unable-to-locate-object-by-name",
  "sec-error-pkcs12-unable-to-export-key",
  "sec-error-pkcs12-unable-to-write",
  "sec-error-pkcs12-unable-to-read",
  "sec-error-pkcs12-key-database-not-initialized",
  "sec-error-keygen-fail",
  "sec-error-invalid-password",
  "sec-error-retry-old-password",
  "sec-error-bad-nickname",
  "sec-error-not-fortezza-issuer",
  "sec-error-cannot-move-sensitive-key",
  "sec-error-js-invalid-module-name",
  "sec-error-js-invalid-dll",
  "sec-error-js-add-mod-failure",
  "sec-error-js-del-mod-failure",
  "sec-error-old-krl",
  "sec-error-ckl-conflict",
  "sec-error-cert-not-in-name-space",
  "sec-error-krl-not-yet-valid",
  "sec-error-crl-not-yet-valid",
  "sec-error-unknown-cert",
  "sec-error-unknown-signer",
  "sec-error-cert-bad-access-location",
  "sec-error-ocsp-unknown-response-type",
  "sec-error-ocsp-bad-http-response",
  "sec-error-ocsp-malformed-request",
  "sec-error-ocsp-server-error",
  "sec-error-ocsp-try-server-later",
  "sec-error-ocsp-request-needs-sig",
  "sec-error-ocsp-unauthorized-request",
  "sec-error-ocsp-unknown-response-status",
  "sec-error-ocsp-unknown-cert",
  "sec-error-ocsp-not-enabled",
  "sec-error-ocsp-no-default-responder",
  "sec-error-ocsp-malformed-response",
  "sec-error-ocsp-unauthorized-response",
  "sec-error-ocsp-future-response",
  "sec-error-ocsp-old-response",
  "sec-error-digest-not-found",
  "sec-error-unsupported-message-type",
  "sec-error-module-stuck",
  "sec-error-bad-template",
  "sec-error-crl-not-found",
  "sec-error-reused-issuer-and-serial",
  "sec-error-busy",
  "sec-error-extra-input",
  "sec-error-unsupported-elliptic-curve",
  "sec-error-unsupported-ec-point-form",
  "sec-error-unrecognized-oid",
  "sec-error-ocsp-invalid-signing-cert",
  "sec-error-revoked-certificate-crl",
  "sec-error-revoked-certificate-ocsp",
  "sec-error-crl-invalid-version",
  "sec-error-crl-v1-critical-extension",
  "sec-error-crl-unknown-critical-extension",
  "sec-error-unknown-object-type",
  "sec-error-incompatible-pkcs11",
  "sec-error-no-event",
  "sec-error-crl-already-exists",
  "sec-error-not-initialized",
  "sec-error-token-not-logged-in",
  "sec-error-ocsp-responder-cert-invalid",
  "sec-error-ocsp-bad-signature",
  "sec-error-out-of-search-limits",
  "sec-error-invalid-policy-mapping",
  "sec-error-policy-validation-failed",
  "sec-error-unknown-aia-location-type",
  "sec-error-bad-http-response",
  "sec-error-bad-ldap-response",
  "sec-error-failed-to-encode-data",
  "sec-error-bad-info-access-location",
  "sec-error-libpkix-internal",
  "sec-error-pkcs11-general-error",
  "sec-error-pkcs11-function-failed",
  "sec-error-pkcs11-device-error",
  "sec-error-bad-info-access-method",
  "sec-error-crl-import-failed",
  "sec-error-expired-password",
  "sec-error-locked-password",
  "sec-error-unknown-pkcs11-error",
  "sec-error-bad-crl-dp-url",
  "sec-error-cert-signature-algorithm-disabled",
  "mozilla-pkix-error-key-pinning-failure",
  "mozilla-pkix-error-ca-cert-used-as-end-entity",
  "mozilla-pkix-error-inadequate-key-size",
  "mozilla-pkix-error-v1-cert-used-as-ca",
  "mozilla-pkix-error-not-yet-valid-certificate",
  "mozilla-pkix-error-not-yet-valid-issuer-certificate",
  "mozilla-pkix-error-signature-algorithm-mismatch",
  "mozilla-pkix-error-ocsp-response-for-cert-missing",
  "mozilla-pkix-error-validity-too-long",
  "mozilla-pkix-error-required-tls-feature-missing",
  "mozilla-pkix-error-invalid-integer-encoding",
  "mozilla-pkix-error-empty-issuer-name",
  "mozilla-pkix-error-additional-policy-constraint-failed",
  "mozilla-pkix-error-self-signed-cert",
  "xp-java-remove-principal-error",
  "xp-java-delete-privilege-error",
  "xp-java-cert-not-exists-error",
  "xp-sec-fortezza-bad-card",
  "xp-sec-fortezza-no-card",
  "xp-sec-fortezza-none-selected",
  "xp-sec-fortezza-more-info",
  "xp-sec-fortezza-person-not-found",
  "xp-sec-fortezza-no-more-info",
  "xp-sec-fortezza-bad-pin",
  "xp-sec-fortezza-person-error",
]);
